
#include <Array.au3>
;~ #include "C:\Users\User\SkyDrive\AutoIt\UDF\I2D_Nano.au3"
#include "INC/I2D_Nano.au3"
#include "INC/HashTable.au3"

; Die Einstellungen habe ich von Hand etwas vorgenommen bis das Ergebnis halbwegs okay aussah.

; ###########
; OBACHT: Es werden garantiert nicht alle Sterne gefunden und es werden auch garantiert welche an stellen gefunden wo nur Rauschen ist
; ###########


Global $MINDESTGROESSE = 3
; 0 von 1x1 px bis NxN px
; 1 von 1x2 bzw 2x1 px bis NxN px
; 2 von 2x2 px bis NxN px
; 3 von 3x3 px bis NxN px

Global Const $MIN_HELLIGKEIT_NXN   = 24   ; Grer  -> weniger Funde (Mindesthelligkeit die ein Stern nach Abzug des Hintergrunds haben muss)

Global Const $MIN_REL_HELLIG_1X1   = 1.65 ; Grer  -> weniger Funde (weniger erlaubte Abweichung zwischen Hell und Dunkel)
Global Const $MAX_STABW_1X1        = 0.30 ; Gibt es nicht, ein Pixel hat keine Standardabweichung

Global Const $MIN_REL_HELLIG_2X1   = 2.10 ; Grer  -> weniger Funde (weniger erlaubte Abweichung zwischen Hell und Dunkel)
Global Const $MAX_STABW_2X1        = 0.30 ; Kleiner -> weniger Funde (weniger erlaubte StAbw im Hellen bereich)

Global Const $MIN_REL_HELLIG_2X2   = 1.50 ; Grer  -> weniger Funde (weniger erlaubte Abweichung zwischen Hell und Dunkel)
Global Const $MAX_STABW_2X2        = 0.25 ; Kleiner -> weniger Funde (weniger erlaubte StAbw im Hellen bereich)

Global Const $MIN_REL_HELLIG_3X3XA = 1    ; Fr groe Sterne gilt quasi: innen heller als auen
Global Const $MIN_REL_HELLIG_3X3AB = 1.1  ; Wie gro das Geflle ist juckt uns wenig.
Global Const $MIN_REL_HELLIG_3X3BC = 1.1  ;
Global Const $MAX_STABW_3X3        = 0.45 ; Mitte


Global Const $COLOR_1X1 = 0xFFFF0000
Global Const $COLOR_1X2 = 0xFF80FF00
Global Const $COLOR_2X1 = 0xFF80FF00
Global Const $COLOR_2X2 = 0xFF4060FF
Global Const $COLOR_3X3 = 0xFFAA4020

Analyse('input.png')


Func Analyse($sFile, $sFileOutput = 'output.txt')
	; Bild hat 8Bit Farbtiefe (Graustufen)
	; Punkte haben eine Gre von 1x1 bis ca. 10x10 und sind mittig heller als auen.


	_GDIPlus_Startup()

	Local $vImg = _I2D_BufferCreateFromFile($sFile)
	Local $vBmp = _I2D_GetLastBitmapStruct()
	Local $vDat = DllStructCreate('byte[' & $vImg.WIDTH * $vImg.HEIGHT & ']')
	Local $iW = $vImg.WIDTH, $iH = $vImg.HEIGHT ; AutoIt der Held macht jedes Mal ein Dllstructgetdata -> kostet unglaublich viel Zeit
	Local $aSum[4], $aCenter[5]

	Local $t = TimerInit()
	For $x = 0 To $vImg.WIDTH - 1 Step 1
		For $y = 0 To $vImg.HEIGHT - 1 Step 1
			DllStructSetData($vDat, 1, DllStructGetData($vBmp, 1, $x + $y * $vImg.WIDTH + 1), $x + $y * $vImg.WIDTH + 1)
		Next
	Next
	ConsoleWrite('ByteStruct: ' & StringFormat('%.2f', TimerDiff($t)/60000) & ' Min' & @CRLF)

	; ##########################################################################################################################
	;   a    X = Startposition                                                                                    Einzelne Pixel
	; a X a  X = Mitte aSum[0]
	;   a    a = Auen aSum[1]
	; ##########################################################################################################################
	If $MINDESTGROESSE < 1 Then
	For $x = 1 To $iW - 2 Step 1      ; Ignorieren: 1px links + 1px rechts
		For $y = 1 To $iH - 2 Step 1 ; Ignorieren: 1px oben  + 1px unten
			$aSum[0] = DllStructGetData($vDat, 1, ($x + 0) + ($y + 0) * $iW + 1) ; Integration ber Mitte
			$aSum[1] = ( _
			DllStructGetData($vDat, 1, ($x - 1) + ($y + 0) * $iW + 1) + _ ; Integration ber Auen
			DllStructGetData($vDat, 1, ($x + 0) + ($y - 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 0) + ($y + 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 1) + ($y + 0) * $iW + 1))/4
			If $aSum[0]/$aSum[1] > $MIN_REL_HELLIG_1X1 And $aSum[0] - $aSum[1] > $MIN_HELLIGKEIT_NXN Then DllStructSetData($vBmp, 1, $COLOR_1X1, ($x + 0) + ($y + 0) * $iW + 1)
		Next
	Next
	ConsoleWrite('Sterne 1x1: ' & StringFormat('%.2f', TimerDiff($t)/60000) & ' Min' & @CRLF)
	EndIf

	; ##########################################################################################################################
	;   a    X = Startposition                                                 Kleine Sterne die zwischen 2px eingescannt wurden
	; a X a  # = Mitte aSum[0]
	; a # a  a = Auen aSum[1]
	;   a
	; ##########################################################################################################################
	If $MINDESTGROESSE < 2 Then
	For $x = 1 To $iW - 2 Step 1      ; Ignorieren: 1px links + 1px rechts
		For $y = 1 To $iH - 3 Step 1 ; Ignorieren: 1px oben  + 2px unten
			If DllStructGetData($vBmp, 1, ($x + 0) + ($y + 0) * $iW + 1) = $COLOR_1X1 Or DllStructGetData($vBmp, 1, ($x + 0) + ($y + 1) * $iW + 1) = $COLOR_1X1 Then ContinueLoop
			$aCenter[0] = DllStructGetData($vDat, 1, ($x + 0) + ($y + 0) * $iW + 1) ; Integration ber Mitte
			$aCenter[1] = DllStructGetData($vDat, 1, ($x + 0) + ($y + 1) * $iW + 1)
			$aSum[0] = ($aCenter[0] + $aCenter[1])/2 ; Wenn die Helligkeitsverteilung nicht passt -> Raus hier.
			If (($aSum[0] - $aCenter[0])^2 + ($aSum[0] - $aCenter[1])^2)^0.5/(2^0.5)/$aSum[0] > $MAX_STABW_2X1 Then ContinueLoop

			$aSum[1] = ( _
			DllStructGetData($vDat, 1, ($x - 1) + ($y + 0) * $iW + 1) + _ ; Integration ber Auen
			DllStructGetData($vDat, 1, ($x - 1) + ($y + 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 0) + ($y - 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 0) + ($y + 2) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 1) + ($y + 0) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 1) + ($y + 1) * $iW + 1))/6
			If $aSum[0]/$aSum[1] > $MIN_REL_HELLIG_2X1 And $aSum[0] - $aSum[1] > $MIN_HELLIGKEIT_NXN Then
				DllStructSetData($vBmp, 1, $COLOR_2X1, ($x + 0) + ($y + 0) * $iW + 1)
				DllStructSetData($vBmp, 1, $COLOR_2X1, ($x + 0) + ($y + 1) * $iW + 1)
			EndIf
		Next
	Next
	ConsoleWrite('Sterne 1x2: ' & StringFormat('%.2f', TimerDiff($t)/60000) & ' Min' & @CRLF)
	EndIf

	; ##########################################################################################################################
	;   a a    X = Startposition                                               Kleine Sterne die zwischen 2px eingescannt wurden
	; a X # a  # = Mitte aSum[0]
	;   a a    a = Auen aSum[1]
	; ##########################################################################################################################
	If $MINDESTGROESSE < 2 Then
	For $x = 1 To $iW - 3 Step 1      ; Ignorieren: 1px links + 2px rechts
		For $y = 1 To $iH - 2 Step 1 ; Ignorieren: 1px oben  + 1px unten
			If DllStructGetData($vBmp, 1, ($x + 0) + ($y + 0) * $iW + 1) = $COLOR_1X1 Or DllStructGetData($vBmp, 1, ($x + 1) + ($y + 0) * $iW + 1) = $COLOR_1X1 Then ContinueLoop
			$aCenter[0] = DllStructGetData($vDat, 1, ($x + 0) + ($y + 0) * $iW + 1) ; Integration ber Mitte
			$aCenter[1] = DllStructGetData($vDat, 1, ($x + 1) + ($y + 0) * $iW + 1)
			$aSum[0] = ($aCenter[0] + $aCenter[1])/2 ; Wenn die Helligkeitsverteilung nicht passt -> Raus hier.
			If (($aSum[0] - $aCenter[0])^2 + ($aSum[0] - $aCenter[1])^2)^0.5/(2^0.5)/$aSum[0] > $MAX_STABW_2X1 Then ContinueLoop

			$aSum[1] = ( _
			DllStructGetData($vDat, 1, ($x - 1) + ($y + 0) * $iW + 1) + _ ; Integration ber Auen
			DllStructGetData($vDat, 1, ($x + 0) + ($y - 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 0) + ($y + 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 1) + ($y - 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 1) + ($y + 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 2) + ($y + 0) * $iW + 1))/6
			If $aSum[0]/$aSum[1] > $MIN_REL_HELLIG_2X1 And $aSum[0] - $aSum[1] > $MIN_HELLIGKEIT_NXN Then
				DllStructSetData($vBmp, 1, $COLOR_2X1, ($x + 0) + ($y + 0) * $iW + 1)
				DllStructSetData($vBmp, 1, $COLOR_2X1, ($x + 1) + ($y + 0) * $iW + 1)
			EndIf
		Next
	Next
	ConsoleWrite('Sterne 2x1: ' & StringFormat('%.2f', TimerDiff($t)/60000) & ' Min' & @CRLF)
	EndIf

	; ##########################################################################################################################
	;   a a     X = Startposition                                                                         Fr mittelgroe Sterne
	; a X # a   # = Mitte aSum[0]
	; a # # a   a = Auen aSum[1]
	;   a a
	; ##########################################################################################################################
	If $MINDESTGROESSE < 3 Then
	For $x = 1 To $iW - 3 Step 1      ; Ignorieren: 1px links + 2px rechts
		For $y = 1 To $iH - 3 Step 1 ; Ignorieren: 1px oben  + 2px unten
			If DllStructGetData($vBmp, 1, ($x + 0) + ($y + 0) * $iW + 1) = $COLOR_1X2 Then ContinueLoop
			If DllStructGetData($vBmp, 1, ($x + 1) + ($y + 0) * $iW + 1) = $COLOR_1X2 Then ContinueLoop
			If DllStructGetData($vBmp, 1, ($x + 0) + ($y + 1) * $iW + 1) = $COLOR_1X2 Then ContinueLoop
			If DllStructGetData($vBmp, 1, ($x + 1) + ($y + 1) * $iW + 1) = $COLOR_1X2 Then ContinueLoop
			$aCenter[0] = DllStructGetData($vDat, 1, ($x + 0) + ($y + 0) * $iW + 1) ; Integration ber Mitte
			$aCenter[1] = DllStructGetData($vDat, 1, ($x + 1) + ($y + 0) * $iW + 1)
			$aCenter[2] = DllStructGetData($vDat, 1, ($x + 0) + ($y + 1) * $iW + 1)
			$aCenter[3] = DllStructGetData($vDat, 1, ($x + 1) + ($y + 1) * $iW + 1)
			$aSum[0] = ($aCenter[0] + $aCenter[1] + $aCenter[2] + $aCenter[3])/4 ; Wenn die Helligkeitsverteilung nicht passt -> Raus hier.
			If (($aSum[0] - $aCenter[0])^2 + ($aSum[0] - $aCenter[1])^2 + ($aSum[0] - $aCenter[2])^2 + ($aSum[0] - $aCenter[3])^2)^0.5/(4^0.5)/$aSum[0] > $MAX_STABW_2X2 Then ContinueLoop

			$aSum[1] = ( _
			DllStructGetData($vDat, 1, ($x - 1) + ($y + 0) * $iW + 1) + _ ; Integration ber Auen
			DllStructGetData($vDat, 1, ($x - 1) + ($y + 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 0) + ($y - 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 0) + ($y + 2) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 1) + ($y - 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 1) + ($y + 2) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 2) + ($y + 0) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 2) + ($y + 1) * $iW + 1))/8
			If $aSum[0]/$aSum[1] > $MIN_REL_HELLIG_2X2 And $aSum[0] - $aSum[1] > $MIN_HELLIGKEIT_NXN Then
				DllStructSetData($vBmp, 1, $COLOR_2X2, ($x + 0) + ($y + 0) * $iW + 1)
				DllStructSetData($vBmp, 1, $COLOR_2X2, ($x + 1) + ($y + 0) * $iW + 1)
				DllStructSetData($vBmp, 1, $COLOR_2X2, ($x + 0) + ($y + 1) * $iW + 1)
				DllStructSetData($vBmp, 1, $COLOR_2X2, ($x + 1) + ($y + 1) * $iW + 1)
			EndIf
		Next
	Next
	ConsoleWrite('Sterne 2x2: ' & StringFormat('%.2f', TimerDiff($t)/60000) & ' Min' & @CRLF)
	EndIf

	; ##########################################################################################################################
	;   c b c     X = Startposition                                          Kleistert alles was hell ist zu -> fr Groe Sterne
	; c a # a c   # = Mitte aSum[0]
	; b # X # b   a = Auen aSum[1]
	; c a # a c   b = Auen aSum[2]
	;   c b c     c = Auen aSum[3]
	; ##########################################################################################################################
	For $x = 2 To $iW - 3 Step 1      ; Ignorieren: 2px links + 2px rechts
		For $y = 2 To $iH - 3 Step 1 ; Ignorieren: 2px oben  + 2px unten
			If DllStructGetData($vBmp, 1, ($x + 0) + ($y + 0) * $iW + 1) = $COLOR_2X2 Then ContinueLoop
			If DllStructGetData($vBmp, 1, ($x - 1) + ($y + 0) * $iW + 1) = $COLOR_2X2 Then ContinueLoop
			If DllStructGetData($vBmp, 1, ($x + 1) + ($y + 0) * $iW + 1) = $COLOR_2X2 Then ContinueLoop
			If DllStructGetData($vBmp, 1, ($x + 0) + ($y - 1) * $iW + 1) = $COLOR_2X2 Then ContinueLoop
			If DllStructGetData($vBmp, 1, ($x + 0) + ($y + 1) * $iW + 1) = $COLOR_2X2 Then ContinueLoop
			$aCenter[0] = DllStructGetData($vDat, 1, ($x + 0) + ($y + 0) * $iW + 1) ; Integration ber Mitte
			$aCenter[1] = DllStructGetData($vDat, 1, ($x - 1) + ($y + 0) * $iW + 1)
			$aCenter[2] = DllStructGetData($vDat, 1, ($x + 1) + ($y + 0) * $iW + 1)
			$aCenter[3] = DllStructGetData($vDat, 1, ($x + 0) + ($y - 1) * $iW + 1)
			$aCenter[4] = DllStructGetData($vDat, 1, ($x + 0) + ($y + 1) * $iW + 1)
			$aSum[0] = ($aCenter[0] + $aCenter[1] + $aCenter[2] + $aCenter[3] + $aCenter[4])/5 ; Wenn die Helligkeitsverteilung nicht passt -> Raus hier.
			If (($aSum[0] - $aCenter[0])^2 + ($aSum[0] - $aCenter[1])^2 + ($aSum[0] - $aCenter[2])^2 + ($aSum[0] - $aCenter[3])^2 + ($aSum[0] - $aCenter[4])^2)^0.5/(5^0.5)/$aSum[0] > $MAX_STABW_3X3 Then ContinueLoop
			$aSum[1] = ( _
			DllStructGetData($vDat, 1, ($x - 1) + ($y - 1) * $iW + 1) + _ ; Integration ber Auen
			DllStructGetData($vDat, 1, ($x - 1) + ($y + 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 1) + ($y - 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 1) + ($y + 1) * $iW + 1))/4
			If Not $aSum[0]/$aSum[1] > $MIN_REL_HELLIG_3X3XA Then ContinueLoop
			$aSum[2] = ( _
			DllStructGetData($vDat, 1, ($x + 0) + ($y - 2) * $iW + 1) + _ ; Integration ber Auen
			DllStructGetData($vDat, 1, ($x + 0) + ($y + 2) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 0) + ($y - 2) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 0) + ($y + 2) * $iW + 1))/4
			If Not $aSum[1]/$aSum[2] > $MIN_REL_HELLIG_3X3AB Then ContinueLoop
			$aSum[3] = ( _
			DllStructGetData($vDat, 1, ($x - 2) + ($y - 1) * $iW + 1) + _ ; Integration ber Auen
			DllStructGetData($vDat, 1, ($x - 2) + ($y + 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x - 1) + ($y - 2) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x - 1) + ($y + 2) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 1) + ($y - 2) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 1) + ($y + 2) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 2) + ($y - 1) * $iW + 1) + _
			DllStructGetData($vDat, 1, ($x + 2) + ($y + 1) * $iW + 1))/8
			If Not $aSum[2]/$aSum[3] > $MIN_REL_HELLIG_3X3BC Then ContinueLoop
			If $aSum[1] - $aSum[3] > $MIN_HELLIGKEIT_NXN Then
				If DllStructGetData($vBmp, 1, ($x - 1) + ($y - 1) * $iW + 1) = $COLOR_1X1 Then DllStructSetData($vBmp, 1, $COLOR_3X3, ($x - 1) + ($y - 1) * $iW + 1)
				If DllStructGetData($vBmp, 1, ($x - 1) + ($y + 1) * $iW + 1) = $COLOR_1X1 Then DllStructSetData($vBmp, 1, $COLOR_3X3, ($x - 1) + ($y + 1) * $iW + 1)
				If DllStructGetData($vBmp, 1, ($x + 1) + ($y - 1) * $iW + 1) = $COLOR_1X1 Then DllStructSetData($vBmp, 1, $COLOR_3X3, ($x + 1) + ($y - 1) * $iW + 1)
				If DllStructGetData($vBmp, 1, ($x + 1) + ($y + 1) * $iW + 1) = $COLOR_1X1 Then DllStructSetData($vBmp, 1, $COLOR_3X3, ($x + 1) + ($y + 1) * $iW + 1)
				DllStructSetData($vBmp, 1, $COLOR_3X3, ($x + 0) + ($y + 0) * $iW + 1)
				DllStructSetData($vBmp, 1, $COLOR_3X3, ($x - 1) + ($y + 0) * $iW + 1)
				DllStructSetData($vBmp, 1, $COLOR_3X3, ($x + 1) + ($y + 0) * $iW + 1)
				DllStructSetData($vBmp, 1, $COLOR_3X3, ($x + 0) + ($y - 1) * $iW + 1)
				DllStructSetData($vBmp, 1, $COLOR_3X3, ($x + 0) + ($y + 1) * $iW + 1)
			EndIf
		Next
	Next
	ConsoleWrite('Sterne 3x3: ' & StringFormat('%.2f', TimerDiff($t)/60000) & ' Min' & @CRLF)

	Local $aTable = HTCreate(50) ; initialgre
	Local $sKey = ''
	For $x = 1 To $iW - 2 Step 1
		For $y = 1 To $iH - 2 Step 1
			Switch DllStructGetData($vBmp, 1, $x + $y * $iW + 1)
				Case $COLOR_1X1
					If HTExists($aTable, '0:' & ($x - 1) & ',' & ($y + 0)) Or HTExists($aTable, '0:' & ($x + 1) & ',' & ($y + 0)) Or _
					   HTExists($aTable, '0:' & ($x + 0) & ',' & ($y - 1)) Or HTExists($aTable, '0:' & ($x + 0) & ',' & ($y + 1)) Then ContinueLoop
					HTInsert($aTable, HTElement('0:' & $x & ',' & $y, ''))
				Case $COLOR_1X2
					If HTExists($aTable, '1:' & ($x - 1) & ',' & ($y + 0)) Or HTExists($aTable, '1:' & ($x + 1) & ',' & ($y + 0)) Or _
					   HTExists($aTable, '1:' & ($x + 0) & ',' & ($y - 1)) Or HTExists($aTable, '1:' & ($x + 0) & ',' & ($y + 1)) Then ContinueLoop
					HTInsert($aTable, HTElement('1:' & $x & ',' & $y, ''))
				Case $COLOR_2X2
					If HTExists($aTable, '2:' & ($x - 1) & ',' & ($y - 1)) Then ContinueLoop
					If HTExists($aTable, '2:' & ($x - 1) & ',' & ($y + 0)) Then ContinueLoop
					If HTExists($aTable, '2:' & ($x - 1) & ',' & ($y + 1)) Then ContinueLoop
					If HTExists($aTable, '2:' & ($x + 1) & ',' & ($y - 1)) Then ContinueLoop
					If HTExists($aTable, '2:' & ($x + 1) & ',' & ($y + 0)) Then ContinueLoop
					If HTExists($aTable, '2:' & ($x + 1) & ',' & ($y + 1)) Then ContinueLoop
					If HTExists($aTable, '2:' & ($x + 0) & ',' & ($y - 1)) Then ContinueLoop
					If HTExists($aTable, '2:' & ($x + 0) & ',' & ($y + 1)) Then ContinueLoop
					HTInsert($aTable, HTElement('2:' & $x & ',' & $y, ''))
				Case $COLOR_3X3
					If HTExists($aTable, '3:' & ($x - 1) & ',' & ($y - 1)) Then ContinueLoop
					If HTExists($aTable, '3:' & ($x - 1) & ',' & ($y + 0)) Then ContinueLoop
					If HTExists($aTable, '3:' & ($x - 1) & ',' & ($y + 1)) Then ContinueLoop
					If HTExists($aTable, '3:' & ($x + 1) & ',' & ($y - 1)) Then ContinueLoop
					If HTExists($aTable, '3:' & ($x + 1) & ',' & ($y + 0)) Then ContinueLoop
					If HTExists($aTable, '3:' & ($x + 1) & ',' & ($y + 1)) Then ContinueLoop
					If HTExists($aTable, '3:' & ($x + 0) & ',' & ($y - 1)) Then ContinueLoop
					If HTExists($aTable, '3:' & ($x + 0) & ',' & ($y + 1)) Then ContinueLoop
					If HTExists($aTable, '3:' & ($x + 2) & ',' & ($y + 0)) Then ContinueLoop
					If HTExists($aTable, '3:' & ($x - 2) & ',' & ($y + 0)) Then ContinueLoop
					If HTExists($aTable, '3:' & ($x + 0) & ',' & ($y - 2)) Then ContinueLoop
					If HTExists($aTable, '3:' & ($x + 0) & ',' & ($y + 2)) Then ContinueLoop
					HTInsert($aTable, HTElement('3:' & $x & ',' & $y, ''))
			EndSwitch
		Next
	Next
	FileDelete($sFileOutput)
	Local $hFile = FileOpen($sFileOutput, 1), $aSplit, $aElement
	FileWrite($hFile, '# siz' & @TAB & ' x' & @TAB & ' y' & @CRLF)
	For $i = 2 To UBound($aTable) - 1 Step 1 ; Hashtable fngt bei 2 an
		$aElement = $aTable[$i]
		If IsArray($aElement) Then
			$aSplit = StringSplit($aElement[0], ',', 2) ; 1:1x1 -> 1:1 und 1
			FileWrite($hFile, '   ' & StringLeft($aSplit[0], 1) & @TAB & StringTrimLeft($aSplit[0], 2) & @TAB & $aSplit[1] & @CRLF)
		EndIf
	Next
	FileClose($hFile)
	ConsoleWrite('Output:     ' & StringFormat('%.2f', TimerDiff($t)/60000) & ' Min' & @CRLF)

;~ 	Local $aStars[4] ; im Index ist die Pixelgre
;~ 	Local $iCol = 0
;~ 	For $x = 1 To $iW - 2 Step 1      ; Ignorieren: 2px links + 2px rechts
;~ 		For $y = 1 To $iH - 2 Step 1 ; Ignorieren: 2px oben  + 2px unten
;~ 			Switch DllStructGetData($vBmp, 1, $x + $y * $iW + 1)
;~ 				Case $COLOR_1X1
;~ 					If StringInStr($aStars[0], ($x - 1) & ',' & ($y + 0), 0, 1) Or StringInStr($aStars[0], ($x + 1) & ',' & ($y + 0), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[0], ($x + 0) & ',' & ($y - 1), 0, 1) Or StringInStr($aStars[0], ($x + 0) & ',' & ($y + 1), 0, 1) Then ContinueLoop
;~ 					$aStars[0] &= $x & ',' & $y & '|'
;~ 				Case $COLOR_1X2, $COLOR_2X1
;~ 					If StringInStr($aStars[1], ($x - 1) & ',' & ($y + 0), 0, 1) Or StringInStr($aStars[1], ($x + 1) & ',' & ($y + 0), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[1], ($x + 0) & ',' & ($y - 1), 0, 1) Or StringInStr($aStars[1], ($x + 0) & ',' & ($y + 1), 0, 1) Then ContinueLoop
;~ 					$aStars[1] &= $x & ',' & $y & '|'
;~ 				Case $COLOR_2X2
;~ 					If StringInStr($aStars[2], ($x - 1) & ',' & ($y - 1), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[2], ($x - 1) & ',' & ($y + 0), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[2], ($x - 1) & ',' & ($y + 1), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[2], ($x + 1) & ',' & ($y - 1), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[2], ($x + 1) & ',' & ($y + 0), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[2], ($x + 1) & ',' & ($y + 1), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[2], ($x + 0) & ',' & ($y - 1), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[2], ($x + 0) & ',' & ($y + 1), 0, 1) Then ContinueLoop
;~ 					$aStars[2] &= $x & ',' & $y & '|'
;~ 				Case $COLOR_3X3
;~ 					If StringInStr($aStars[3], ($x - 1) & ',' & ($y - 1), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[3], ($x - 1) & ',' & ($y + 0), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[3], ($x - 1) & ',' & ($y + 1), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[3], ($x + 1) & ',' & ($y - 1), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[3], ($x + 1) & ',' & ($y + 0), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[3], ($x + 1) & ',' & ($y + 1), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[3], ($x + 0) & ',' & ($y - 1), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[3], ($x + 0) & ',' & ($y + 1), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[3], ($x + 2) & ',' & ($y + 0), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[3], ($x - 2) & ',' & ($y + 0), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[3], ($x + 0) & ',' & ($y - 2), 0, 1) Then ContinueLoop
;~ 					If StringInStr($aStars[3], ($x + 0) & ',' & ($y + 2), 0, 1) Then ContinueLoop
;~ 					$aStars[3] &= $x & ',' & $y & '|'
;~ 			EndSwitch
;~ 		Next
;~ 	Next
;~ 	FileDelete($sFileOutput)
;~ 	Local $hFile = FileOpen($sFileOutput, 1), $aSplit, $aSplit2
;~ 	FileWrite($hFile, '# size' & @TAB & 'x' & @TAB & 'y' & @CRLF)
;~ 	For $i = $MINDESTGROESSE To UBound($aStars) - 1 Step 1
;~ 		$aSplit = StringSplit(StringTrimRight($aStars[$i], 1), '|')
;~ 		For $ii = 1 To $aSplit[0] Step 1
;~ 			$aSplit2 = StringSplit($aSplit[$ii], ',', 2)
;~ 			FileWrite($hFile, $i & @TAB & $aSplit2[0] & @TAB & $aSplit2[1] & @CRLF)
;~ 		Next
;~ 	Next
;~ 	FileClose($hFile)
;~ 	ConsoleWrite('Output:     ' & StringFormat('%.2f', TimerDiff($t)/60000) & ' Min' & @CRLF)

	_I2D_BufferSaveToFile($vImg, 'Veranschaulichung.png')


	_GDIPlus_Shutdown()
EndFunc

